# Contributing to image2D

1. [Getting Involved](#getting-involved)
2. [Questions and Discussion](#questions-and-discussion)
3. [How To Report Bugs](#how-to-report-bugs)
4. [How to Participates](#how-to-participate)

Note:这是一个仅仅专注于 *image2D code* 本身开发的项目，在你提出[issue](https://github.com/yelloxing/image2D/issues)或创建[pull request](https://github.com/yelloxing/image2D/pulls)的时候，请确定你选择了正确的方式。
* 如果是错误或缺陷，请选择[【错误或缺陷设计】](https://github.com/yelloxing/image2D/issues/new/choose)模板，报告具体的错误信息以帮助我们改进。
* 如果是给出建议，请选择[【建议或改进意】](https://github.com/yelloxing/image2D/issues/new/choose)模板，在未来的项目设计中，会把这里的意见考虑进去。
* 如果是有疑惑，请选择[【疑惑或不清楚的地方】](https://github.com/yelloxing/image2D/issues/new/choose)模板。

## Getting Involved

本库致力于提供更简单的Web端二维绘图接口，主要包括这些方面：画笔、辅助计算、结点操作和一些零碎的小工具方法。我们希望绘图是简单而有趣的、高效而愉悦的！

主要是在svg和canvas2D上绘图，虽然有提供比如Maritx4坐标变换等三维相关方法，这是考虑到一些潜在的需求。

## Questions and Discussion
所有的问题，包括疑惑等，都可以提[issue](https://github.com/yelloxing/image2D/issues)进行讨论。

## How to Report Bugs
错误等请同样的提[issue](https://github.com/yelloxing/image2D/issues)。

## How to Participate

- 【代码维护】认领[issue](https://github.com/yelloxing/image2D/issues)中提出的问题或改进等任务，修改后提交推送（请推送到dev分支）。

- 【文档维护】位于docs下的接口API的维护工作，针对描述不准确或需要补充等地方，进行文案修改。

- 【用例开发】[Image Demo](https://github.com/yelloxing/Image-Demo)中维护的是基于image2D开发的用例。

- 【测试】目前测试位于test文件夹中，分为用例测试、单元测试和基准测试，你可以对不合理的用例进行修改或针对未涉及的用例进行添加（测试时发现问题可以提[issue](https://github.com/yelloxing/image2D/issues)）。

- 【建议或需求】如果你在使用过程中对image2D的设计有好的想法，可以提[issue](https://github.com/yelloxing/image2D/issues)给出。

以上任何条目有不清楚或疑惑的地方，都可以提[issue](https://github.com/yelloxing/image2D/issues)进行提问。
